AboutDlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL buffer[128]:byte
	LOCAL InfoOut:dword
	LOCAL lpdwHandle:dword
	LOCAL nbytes:dword
	LOCAL dwChar:dword
	LOCAL pLang:dword
	LOCAL hHeap:dword
	LOCAL pMem:dword
	
	_try offset ED_01

	push edx
	push edi
	push esi
	push ebx

; ======================================================================================================================
	.if uMsg==WM_INITDIALOG
		invoke LoadIcon,hInstance,IDI_ACTIVEX
		invoke SendMessage,hWin,WM_SETICON,NULL,eax
		invoke SendDlgItemMessage,hWin,IDC_EDT3,WM_SETTEXT,0,addr szLicence 
		
		invoke GetFileVersionInfoSize,addr szComToolDll,addr lpdwHandle
		.if eax!=0
			mov nbytes,eax
		    invoke GetProcessHeap 
		    .if eax!=0 
		        mov hHeap,eax 
		        invoke HeapAlloc,eax,0,nbytes 
		        .if eax!=0 
		        	mov pMem,eax
					invoke GetFileVersionInfo,addr szComToolDll,0,nbytes,pMem
					.if eax!=0
						invoke VerQueryValue,pMem,addr szLang,addr pLang,addr dwChar
						.if eax!=0 && dwChar!=0
							mov eax,pLang
			         		movzx ecx,[eax.LANGANDCODEPAGE].wLanguage 
			         		movzx edx,[eax.LANGANDCODEPAGE].wCodepage 
							;Product version 1.0.0.0
							invoke wsprintf,addr buffer,addr szProductVersion,ecx,edx
							invoke VerQueryValue,pMem,addr buffer,addr InfoOut,addr dwChar
							.if eax!=0 && dwChar!=0
								invoke wsprintf,addr buffer,addr szVersion,InfoOut
								invoke SetDlgItemText,hWin,IDC_STC4,addr buffer
							.endif
							;File version day/month/year
							mov eax,pLang
			         		movzx ecx,[eax.LANGANDCODEPAGE].wLanguage 
			         		movzx edx,[eax.LANGANDCODEPAGE].wCodepage 
							invoke wsprintf,addr buffer,addr szFileVersion,ecx,edx
							invoke VerQueryValue,pMem,addr buffer,addr InfoOut,addr dwChar
							.if eax!=0 && dwChar!=0
								invoke wsprintf,addr buffer,addr szDate,InfoOut
								invoke SetDlgItemText,hWin,IDC_STC7,addr buffer
							.endif
							
						.endif
					.endif
					invoke HeapFree,hHeap,0,pMem
				.endif
			.endif
		.endif
		xor eax,eax
	.elseif uMsg==WM_COMMAND
		mov edx,wParam
		mov eax,edx
		shr edx,16
		.if dx==BN_CLICKED
			.if ax==IDC_BTN6 ;OK
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	
	.elseif uMsg==WM_CTLCOLOREDIT
		invoke GetWindowLong,lParam,GWL_ID
		.if eax==IDC_EDT3
			invoke SetBkMode,wParam,TRANSPARENT
			invoke CreateSolidBrush,colref
			ret
		.endif
		mov eax,FALSE
		jmp return
		
	.elseif uMsg==WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov eax,FALSE
		jmp return
	.endif
	mov eax,TRUE
; ======================================================================================================================

return:
	pop ebx
	pop esi
	pop edi
	pop edx
	_finally
	ret

AboutDlgProc endp

