
include ComTut.inc

.code

start:
	invoke GetModuleHandle,NULL
	mov hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

DlgProc proc uses edi esi edx hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	mov eax,uMsg
	.if eax==WM_INITDIALOG
		push hWin
		pop hDlg
		invoke GetDlgItem,hWin,IDC_Visible
		mov hVisibleE,eax
		invoke GetDlgItem,hWin,IDC_WindowState
		mov hWindowStateE,eax
		invoke GetDlgItem,hWin,IDC_AddBook
		mov hAddBook,eax
		invoke GetDlgItem,hWin,IDC_OpenBook
		mov hOpenBook,eax
		invoke GetDlgItem,hWin,IDC_OpenROE
		mov hOpenROE,eax
		invoke GetDlgItem,hWin,IDC_CloseBook
		mov hCloseBook,eax
		invoke GetDlgItem,hWin,IDC_CloseAllBooks
		mov hCloseAllBooks,eax
		invoke GetDlgItem,hWin,IDC_CloseNamedBook
		mov hCloseNamedBook,eax
		invoke GetDlgItem,hWin,IDC_CloseActiveBook
		mov hCloseActiveBook,eax
		invoke GetDlgItem,hWin,IDC_Quit
		mov hQuitE,eax
		invoke GetDlgItem,hWin,IDC_nBooks
		mov hnBooks,eax
		invoke GetDlgItem,hWin,IDC_StartExcel
		mov hStartExcel,eax
		invoke GetDlgItem,hWin,IDC_PutToCell
		mov hPutToCell,eax
		invoke GetDlgItem,hWin,IDC_GetFromCell
		mov hGetFromCell,eax
		invoke GetDlgItem,hWin,IDC_SumCells
		mov hSumCells,eax
		invoke GetDlgItem,hWin,IDC_Pi
		mov hPi,eax
		invoke GetDlgItem,hWin,IDC_GradToRad
		mov hGradToRad,eax
		
	.elseif eax==WM_COMMAND
		mov eax,wParam
		mov edx,eax
		shr edx,16
		and eax,0FFFFh
		.if edx==BN_CLICKED
			.if eax==IDC_ClearUpper
				invoke SetDlgItemText,hWin,IDC_EDT1,0
				
			.elseif eax==IDC_ClearLower
				invoke SetDlgItemText,hWin,IDC_EDT2,0
				
; Excel=================================================================================================
			.elseif eax==IDC_StartExcel
				
		;visible
			.elseif eax==IDC_Visible

		;window state
			.elseif eax==IDC_WindowState
	
		;add a book
			.elseif eax==IDC_AddBook
				
		;open a book
			.elseif eax==IDC_OpenBook
				invoke OpenDlg,hWin,addr szExcelExt
				
		;open a book read only
			.elseif eax==IDC_OpenROE
				invoke OpenDlg,hWin,addr szExcelExt
				
		;Number of open books	
			.elseif eax==IDC_nBooks
	
		;Close last opened book	
			.elseif eax==IDC_CloseBook
				
		;Close all books		
			.elseif eax==IDC_CloseAllBooks
	
		;Close named book
			.elseif eax==IDC_CloseNamedBook
				
		;Close active book
			.elseif eax==IDC_CloseActiveBook
				
		;Put to cell
			.elseif eax==IDC_PutToCell
				
		;Get from cell
			.elseif eax==IDC_GetFromCell
				
		;Sum Cells
			.elseif eax==IDC_SumCells
				
		;Pi
			.elseif eax==IDC_Pi
				
		;Grad to Rad
			.elseif eax==IDC_GradToRad
				
		;Quit Excel
			.elseif eax==IDC_Quit
				
			.endif
		.endif
		
	.elseif eax==WM_CLOSE
		
		invoke EndDialog,hWin,0
		
	.else
		mov eax,FALSE
		ret
	.endif
	ret

DlgProc endp

OpenDlg proc uses edi esi edx hWin:dword,pExt:dword
	
	mov ofn.lStructSize,SIZEOF ofn
	push hWin
	pop  ofn.hWndOwner
	push hInstance
	pop  ofn.hInstance
	invoke GetCurrentDirectory,128,addr InitDir
	mov ofn.lpstrInitialDir,offset InitDir
	mov eax,pExt
	mov  ofn.lpstrFilter,eax
	invoke RtlZeroMemory,addr FilePath,sizeof FilePath
	mov ofn.lpstrFile, OFFSET FilePath
	mov ofn.nMaxFile,256
	mov ofn.Flags,OFN_PATHMUSTEXIST or OFN_LONGNAMES or\
            OFN_EXPLORER or OFN_HIDEREADONLY
	invoke GetOpenFileName,addr ofn
	ret
	
OpenDlg endp

end start