ComponentInterfaces proc pLib:dword
;Listing the interfaces of the choosen component
;Create TypeLibInfo object

	LOCAL pCoClasses:dword
	LOCAL pCoClassInfo:dword
	
	LOCAL lpWideCharStr[2048]:byte
	LOCAL clsidApp:GUID
	LOCAL pWideAllocStr:dword
	LOCAL number:dword
	LOCAL buffer[2048]:byte
	LOCAL buffer2[2048]:byte
	LOCAL printtext[2048]:byte
	LOCAL x:dword
	LOCAL processaddr:dword
	
	_try offset ED_09 ;address of frame-based exception director

	push edx
	push edi
	push esi
	push ebx
	
; ======================================================================================================================
	mov pCoClasses,0
	mov pCoClassInfo,0
	mov pTypeLibInfo,0

	invoke MultiByteToWideChar,CP_ACP,0,addr szTLILib,-1,addr lpWideCharStr,sizeof lpWideCharStr
	invoke CLSIDFromProgID,addr lpWideCharStr,addr clsidApp
	
;Set T = CreateObject("Excel.Application")
	invoke CoCreateInstance,addr clsidApp,0,CLSCTX_SERVER,addr IID__TypeLibInfo,addr pTypeLibInfo
	.if eax==S_OK && pTypeLibInfo!=0
		invoke MultiByteToWideChar,CP_ACP,0,pLib,-1,addr lpWideCharStr,sizeof lpWideCharStr
		invoke SysAllocString,addr lpWideCharStr
		mov pWideAllocStr,eax
		
;T.ContainingFile = "Filepath"
		mov eax,pTypeLibInfo
		mov edx,dword ptr [eax]
		push pWideAllocStr
		push pTypeLibInfo
		;call _TypeLibInfo.put_ContainingFile
		call dword ptr [edx+10*4]
		.if eax==S_OK
		
;T.Name (=Excel)
			mov eax,pTypeLibInfo
			mov edx,dword ptr [eax]
			lea eax,pWideAllocStr
			push eax
			push pTypeLibInfo
			;call _TypeLibInfo.get_Name
			call dword ptr [edx+12*4]
			.if eax==S_OK
				invoke WideCharToMultiByte,CP_ACP,0,pWideAllocStr,-1,addr buffer,sizeof buffer,0,0
				invoke SysFreeString,pWideAllocStr
			.endif
			
;T.CoClasses
			mov eax,pTypeLibInfo
			mov edx,dword ptr [eax]
			lea eax,pCoClasses
			push eax  ;ptr to ptr to function: CoClasses
			push pTypeLibInfo
			;call _TypeLibInfo.get_CoClasses
			call dword ptr [edx+23*4]
			.if eax==S_OK
			
;T.CoClasses.Count
				mov eax,pCoClasses
				mov edx,dword ptr [eax]
				lea eax,number
				push eax ;ptr/VT_I2/
				push pCoClasses
				;call CoClasses.get_Count
				call dword ptr [edx+10*4]
				.if eax==S_OK
					and number,0ffffh
					xor ecx,ecx
					inc ecx
					mov x,0
					.while ecx<=number
						push ecx
						
;T.CoClasses(i)
						mov eax,pCoClasses
						mov edx,dword ptr [eax]
						lea eax,pCoClassInfo  
						push eax ;ptr to ptr to function: CoClassInfo
						;Params( Index)
						push ecx
						push pCoClasses
						;call CoClasses.get_Item
						call dword ptr [edx+11*4]
						.if eax==S_OK
						
;T.CoClasses(i).Name
							mov eax,pCoClassInfo
							mov edx,dword ptr [eax]
							lea eax,pWideAllocStr
							push eax
							push pCoClassInfo
							;call CoClassInfo.get_Name
							call dword ptr [edx+9*4]
							.if eax==S_OK
								invoke AddListViewItem,x
								invoke WideCharToMultiByte,CP_ACP,0,pWideAllocStr,-1,addr buffer2,sizeof buffer2,0,0
								invoke SysFreeString,pWideAllocStr
								invoke wsprintf,addr printtext,addr szComponent,addr buffer,addr buffer2
								;Write example "Excel.
								invoke putTextMatrix,x,1,addr printtext
							.endif
							
;T.CoClasses(i).Guid
							mov eax,pCoClassInfo
							mov edx,dword ptr [eax]
							lea eax,pWideAllocStr
							push eax
							push pCoClassInfo
							;call CoClassInfo.get_GUID
							call dword ptr [edx+10*4]
							.if eax==S_OK
								invoke WideCharToMultiByte,CP_ACP,0,pWideAllocStr,-1,addr buffer2,sizeof buffer2,0,0
								invoke SysFreeString,pWideAllocStr
								invoke putTextMatrix,x,2,addr buffer2
							.endif
							invoke IDispRelease,addr pCoClassInfo
						.endif
						inc x
						pop ecx
						inc ecx
					.endw
				.endif
				invoke IDispRelease,addr pCoClasses
			.endif
		.endif
		mov eax,TRUE 
	.else
		invoke LoadLibrary,addr szTlbInf32DLL
		.if eax!=0
			mov hTlbInf32DLL,eax
			invoke GetProcAddress,eax,addr szDllRegSvr
			.if eax!=0
				mov processaddr,eax
				invoke MessageBox,0,addr szRegQuestion,addr szComTool,MB_ICONQUESTION or MB_YESNO
				.if eax==IDYES
					call processaddr
				.endif
				invoke FreeLibrary,hTlbInf32DLL
			.endif
		.endif
		mov eax,FALSE 
	.endif
; ======================================================================================================================

return:
	pop ebx
	pop esi
	pop edi
	pop edx
	_finally
	ret

ComponentInterfaces endp

