QuickSearch proc Row:dword,Col:dword,pText:dword
			
	_try offset ED_37 ;address of frame-based exception director
	
	push edx
	push edi
	push esi

; ======================================================================================================================
	;Allocate a handle of a statement
	invoke SQLAllocHandle,SQL_HANDLE_STMT,hConn,addr hStmt
	.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
		invoke SQLSetStmtAttr,hStmt,SQL_ATTR_CURSOR_TYPE,SQL_CURSOR_STATIC,0
		invoke SQLExecDirect,hStmt,addr szQuickSaveOutStmt,sizeof szQuickSaveOutStmt
		invoke SQLFetchScroll,hStmt,SQL_FETCH_ABSOLUTE,Row
		invoke SQLGetData,hStmt,Col,SQL_C_CHAR,pText,256,0
		invoke SQLCloseCursor,hStmt
		invoke SQLFreeStmt,hStmt,SQL_CLOSE
		mov eax,TRUE 
		jmp return
	.endif
	mov eax,FALSE 
; ======================================================================================================================

return:
	pop esi
	pop edi
	pop edx
	_finally
	ret
	
QuickSearch endp

QuickSearchSave proc Row:dword,pName:dword,pPath:dword
	LOCAL buffer2[512]:byte
	
	_try offset ED_39 ;address of frame-based exception director
	
	push edx
	push edi
	push esi

; ======================================================================================================================
	;Allocate a handle of a statement
	invoke SQLAllocHandle,SQL_HANDLE_STMT,hConn,addr hStmt
	.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
		invoke SQLSetStmtAttr,hStmt,SQL_ATTR_CURSOR_TYPE,\
					SQL_CURSOR_STATIC,0
		
		invoke wsprintf,addr buffer2,addr szQuickSaveInStmt,pName,pPath,Row
		invoke SQLCloseCursor,hStmt
		invoke SQLExecDirect,hStmt,addr buffer2,sizeof buffer2
		.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
			invoke SQLCloseCursor,hStmt
			invoke SQLFreeStmt,hStmt,SQL_CLOSE
			mov eax,TRUE 
			jmp return
		.endif
	.endif
	invoke SQLCloseCursor,hStmt
	invoke SQLFreeStmt,hStmt,SQL_CLOSE
	mov eax,FALSE 
; ======================================================================================================================

return:
	pop esi
	pop edi
	pop edx
	_finally
	ret
	
QuickSearchSave endp

