VariantHelp proc pText:dword,pTextOut:dword
	
	_try offset ED_45 ;address of frame-based exception director
	
	push edx
	push edi
	push esi

; ======================================================================================================================
	;Allocate a handle of a statement
	invoke SQLAllocHandle,SQL_HANDLE_STMT,hConn,addr hStmt
	.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
		invoke SQLSetStmtAttr,hStmt,SQL_ATTR_CURSOR_TYPE,\
					SQL_CURSOR_STATIC,0
		invoke SQLExecDirect,hStmt,pText,128
		invoke SQLFetch,hStmt
		invoke SQLGetData,hStmt,1,SQL_C_CHAR,pTextOut,128,0
		invoke SQLCloseCursor,hStmt
		invoke SQLFreeStmt,hStmt,SQL_CLOSE
	.endif
; ======================================================================================================================

return:
	pop esi
	pop edi
	pop edx
	_finally
	ret

VariantHelp endp

getCodeSnippet proc Col:dword,pCode:dword
	
	_try offset ED_15 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
; ======================================================================================================================
	;Allocate a handle of a statement
	invoke SQLAllocHandle,SQL_HANDLE_STMT,hConn,addr hStmt
	.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
		invoke SQLSetStmtAttr,hStmt,SQL_ATTR_CURSOR_TYPE,\
					SQL_CURSOR_STATIC,0
		invoke SQLExecDirect,hStmt,addr szGetCode,sizeof szGetCode
		invoke SQLFetchScroll,hStmt,SQL_FETCH_ABSOLUTE,1
		invoke SQLGetData,hStmt,Col,SQL_C_CHAR,pCode,4096,0
		invoke SQLFetchScroll,hStmt,SQL_FETCH_ABSOLUTE,2
		invoke SQLGetData,hStmt,Col,SQL_C_CHAR,addr InfoStr,2048,0

		invoke SQLCloseCursor,hStmt
		invoke SQLFreeStmt,hStmt,SQL_CLOSE
	.endif
; ======================================================================================================================

return:
	pop esi
	pop edi
	pop edx
	_finally
	ret

getCodeSnippet endp

getMacros proc Col:dword,pCode:dword
	
	_try offset ED_19 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
; ======================================================================================================================
	;Allocate a handle of a statement
	invoke SQLAllocHandle,SQL_HANDLE_STMT,hConn,addr hStmt
	.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
		invoke SQLSetStmtAttr,hStmt,SQL_ATTR_CURSOR_TYPE,\
					SQL_CURSOR_STATIC,0
		invoke SQLExecDirect,hStmt,addr szGetMacro,sizeof szGetCode
		invoke SQLFetchScroll,hStmt,SQL_FETCH_ABSOLUTE,1
		invoke SQLGetData,hStmt,Col,SQL_C_CHAR,pCode,4096,0
		invoke SQLFetchScroll,hStmt,SQL_FETCH_ABSOLUTE,2
		invoke SQLGetData,hStmt,Col,SQL_C_CHAR,addr InfoStr,2048,0
		invoke SQLCloseCursor,hStmt
		invoke SQLFreeStmt,hStmt,SQL_CLOSE
	.endif
; ======================================================================================================================

return:
	pop esi
	pop edi
	pop edx
	_finally
	ret

getMacros endp

