AddListViewItem proc Row:dword
	LOCAL buffer[2048]:byte
	LOCAL lvi:LV_ITEM

	_try offset ED_02 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
	push ecx

; ======================================================================================================================
	mov lvi.imask,LVIF_TEXT
    inc Row
    push Row
    pop lvi.iItem
    mov lvi.iSubItem,0

    invoke wsprintf,addr buffer,addr szValue,Row
    lea eax,buffer
    mov lvi.pszText,eax
    invoke SendMessage,hLSV1,LVM_INSERTITEM,0,addr lvi
; ======================================================================================================================

return:
	pop ecx
	pop esi
	pop edi
	pop edx
	_finally
	mov eax,TRUE
	ret

AddListViewItem endp

CompareFunc proc lParam1:DWORD, lParam2:DWORD, sort:DWORD
	LOCAL buffer[256]:byte
	LOCAL buffer2[256]:byte
	LOCAL lvi:LV_ITEM
	
	_try offset ED_08 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
	push ecx

; ======================================================================================================================
	invoke RtlZeroMemory,addr buffer,sizeof buffer
	invoke RtlZeroMemory,addr buffer2,sizeof buffer2
	mov lvi.imask,LVIF_TEXT
	lea eax,buffer
	mov lvi.pszText,eax
	mov lvi.cchTextMax,256
	.if SortType==1 ;Original order, i.e. as the numbers in column No
		mov lvi.iSubItem,0
		invoke SendMessage,hLSV1,LVM_GETITEMTEXT,lParam1,addr lvi
		invoke String2Dword,addr buffer
		mov edi,eax
		invoke SendMessage,hLSV1,LVM_GETITEMTEXT,lParam2,addr lvi
		invoke String2Dword,addr buffer
		sub edi,eax
		mov eax,edi
	.elseif SortType==0 ;Ascending order
		mov lvi.iSubItem,1
		invoke SendMessage,hLSV1,LVM_GETITEMTEXT,lParam1,addr lvi
		invoke lstrcpy,addr buffer2,addr buffer
		invoke SendMessage,hLSV1,LVM_GETITEMTEXT,lParam2,addr lvi
		invoke lstrcmpi,addr buffer2,addr buffer	
	.endif
; ======================================================================================================================

return:
	pop ecx
	pop esi
	pop edi
	pop edx
	_finally
	ret
	
CompareFunc endp

String2Dword proc String:DWORD
	LOCAL Result:DWORD

	_try offset ED_42 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
	push ecx

; ======================================================================================================================
	mov Result,0
    mov edi,String
    invoke lstrlen,String
    .while eax!=0
            xor edx,edx
            mov dl,byte ptr [edi]
            sub dl,"0"      ; subtrack each digit with "0" to convert it to hex value
            mov esi,eax
            dec esi
            push eax
            mov eax,edx
            push ebx
            mov ebx,10
            .while esi > 0
                    mul ebx
                    dec esi
            .endw
            pop ebx
            add Result,eax
            pop eax
            inc edi
            dec eax
    .endw
; ======================================================================================================================

return:
	pop ecx
	pop esi
	pop edi
	pop edx
	_finally
    mov eax,Result
    ret
String2Dword endp

UpdatelParam proc 
	LOCAL lvi:LV_ITEM
	
	_try offset ED_43 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
	push ecx

; ======================================================================================================================
	invoke SendMessage,hLSV1, LVM_GETITEMCOUNT,0,0
	mov edi,eax
	mov lvi.imask,LVIF_PARAM
	mov lvi.iSubItem,0
	mov lvi.iItem,0
	.while edi>0
		push lvi.iItem
		pop lvi.lParam
		invoke SendMessage,hLSV1, LVM_SETITEM,0,addr lvi
		inc lvi.iItem
		dec edi
	.endw
; ======================================================================================================================

return:
	pop ecx
	pop esi
	pop edi
	pop edx
	_finally
	ret
	
UpdatelParam endp

