MainDlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL buffer[4096]:byte
	LOCAL buffer2[256]:byte
	LOCAL buffer3[256]:byte
	LOCAL printout[4096]:byte
	LOCAL pos:dword
	LOCAL hdi:HD_ITEM
	
	_try offset ED_31 ;address of frame-based exception director

	push edx
	push edi
	push esi
	push ebx

; ======================================================================================================================
	.if uMsg==WM_INITDIALOG
		push hWin
		pop hMainDlg
		invoke CoInitializeEx,0,0

		invoke LoadIcon,hInstance,IDI_ACTIVEX
		invoke SendMessage,hWin,WM_SETICON,NULL,eax
		invoke GetDlgItem,hWin,IDC_LSV1
		mov hLSV1,eax
		invoke GetDlgItem,hWin,IDC_BTN_CLASSES
		mov hBTN6,eax
		invoke GetDlgItem,hWin,IDC_BTN_Close
		mov hBTN7,eax
		invoke GetDlgItem,hWin,IDC_BTN_ENUMERATIONS
		mov hBTN8,eax
		invoke GetDlgItem,hWin,IDC_BTN_IIDs
		mov hBTN9,eax
		invoke GetDlgItem,hWin,IDC_BTN_INTERFACES
		mov hBTN10,eax
		invoke GetDlgItem,hWin,IDC_SBR1
		mov hSBR1,eax
		invoke GetMenu,hWin
		mov hMenu,eax
		
		invoke SendMessage,hLSV1,LVM_SETBKCOLOR,0,00B7FFFFh
		invoke SendMessage,hLSV1,LVM_SETTEXTBKCOLOR,0,00B7FFFFh
		
		invoke ODBCConnect,hWin
		
		mov SortType,0
		
	.elseif uMsg==WM_INITMENUPOPUP
		mov eax,lParam
		;IDM_SearchLibs menuitem==============================================
		.if ax==0
			invoke RtlZeroMemory,addr buffer,sizeof buffer
			invoke QuickSearch,1,2,addr buffer
			.if eax==TRUE 
				invoke ModifyMenu,hMenu,IDM_QuickExcel,MF_BYCOMMAND,IDM_QuickExcel,addr buffer
			.endif
			invoke QuickSearch,2,2,addr buffer
			.if eax==TRUE 
				invoke ModifyMenu,hMenu,IDM_QuickWinword,MF_BYCOMMAND,IDM_QuickWinword,addr buffer
			.endif
		.endif
		
	.elseif uMsg==WM_COMMAND
		mov eax,wParam
; MENU ===========================================================================================
		.if lParam==0
			.if ax==IDM_OpenLib ;Index=0
				invoke FileOpenDlg,hWin,addr szOpenLib,addr szFilter,addr buffer
				.if eax==TRUE 
					invoke OpenComponent,addr buffer
				.endif
				
			.elseif ax==IDM_QuickExcel ;Index=1
				invoke RtlZeroMemory,addr buffer,sizeof buffer
				invoke QuickSearch,1,3,addr buffer
				invoke lstrlen,addr buffer
				.if eax!=0
					invoke OpenComponent,addr buffer
				.else
					xor eax,eax
					mov eax,IDM_ListAll
					invoke SendMessage,hWin,WM_COMMAND,eax,0
				.endif
				
			.elseif ax==IDM_QuickWinword ;Index=2
				invoke RtlZeroMemory,addr buffer,sizeof buffer
				invoke QuickSearch,2,3,addr buffer
				invoke lstrlen,addr buffer
				.if eax!=0
					invoke OpenComponent,addr buffer
				.else
					xor eax,eax
					mov eax,IDM_ListAll
					invoke SendMessage,hWin,WM_COMMAND,eax,0
				.endif
				
			.elseif ax==IDM_ListAll ;Index=4
				invoke LoadCursor,0,IDC_WAIT
				invoke SetCursor,eax
				invoke ButtonState,FALSE 
				invoke InsertColumns,4,addr szHeading1,50,addr szHeading2,250,\
					addr szHeading3,500,addr szHeading4,300

				invoke ShowWindow,hLSV1,SW_HIDE
				invoke ListLib,4,TRUE,0
				invoke ShowWindow,hLSV1,SW_SHOW
				
				invoke SetWindowText,hWin,addr szTypeLibList
				mov SortType,0
				
			.elseif ax==IDM_InitiateCOM
				mov edx,1
				call Snippets
				
			.elseif ax==IDM_CreateObject
				mov edx,2
				call Snippets
				
			.elseif ax==IDM_WideStringIn
				mov edx,3
				call Snippets
				
			.elseif ax==IDM_WideStringOut
				mov edx,4
				call Snippets
				
			.elseif ax==IDM_Variantstructure
				mov edx,5
				call Snippets
				
			.elseif ax==IDM_disparstructure
				mov edx,6
				call Snippets
				
			.elseif ax==IDM_IDNullGUID
				mov edx,7
				call Snippets
				
			.elseif ax==IDM_IDispRelease
				mov edx,8
				call Snippets
				
			.elseif ax==IDM_IDispInvoke
				mov edx,9
				call Snippets
				
			.elseif ax==IDM_try
				mov edx,10
				call Snippets
				
			.elseif ax==IDM_finally
				mov edx,11
				call Snippets
				
			.elseif ax==IDM_ExceptionHandler
				mov edx,12
				call Snippets
				
			.elseif ax==IDM_Par
				mov edx,2
				call Macros
				
			.elseif ax==IDM_NoPar
				mov edx,1
				call Macros
				
			.elseif ax==IDM_Functions
				.if hRichEditDLL==0
					invoke LoadLibrary,offset szRichEditDLL
					mov hRichEditDLL,eax
				.endif
				invoke DialogBoxParam,hInstance,IDD_DIALOG4,hWin,addr VBBrowserProc,TKIND_DISPATCH
				
			.elseif ax==IDM_Enumerations
				.if hRichEditDLL==0
					invoke LoadLibrary,offset szRichEditDLL
					mov hRichEditDLL,eax
				.endif
				invoke DialogBoxParam,hInstance,IDD_DIALOG4,hWin,addr VBBrowserProc,TKIND_ENUM
				
			.elseif ax==IDM_ParameterHelp
				invoke DialogBoxParam,hInstance,IDD_DIALOG7,hWin,addr VariantDlgProc,0
				
			.elseif ax==IDM_RegisterModule
				invoke FileOpenDlg,hWin,addr szOpenLib,addr szFilter,addr buffer
				.if eax==TRUE 
					invoke ShellExecute,hWin,addr szOpen,addr szRegsvr32,addr buffer,0,0					
				.endif
				
			.elseif ax==IDM_UnregisterModule
				invoke InsertColumns,4,addr szHeading1,50,addr szHeading2,250,\
					addr szHeading3,500,addr szHeading4,300

				invoke ShowWindow,hLSV1,SW_HIDE
				invoke ListLib,4,TRUE,0
				invoke ShowWindow,hLSV1,SW_SHOW
				
				invoke SetWindowText,hWin,addr szTypeLibList
				mov SortType,0
				invoke MessageBox,hWin,addr szUnreg,addr szComTool,MB_OKCANCEL or MB_ICONINFORMATION
				.if eax==IDOK
					mov flUnreg,TRUE 
					
				.endif 
				
			.elseif ax==IDM_SubHelp
				invoke lstrlen,addr HelpFile
				.if eax==0
					invoke MessageBox,0,addr szNoHelp,addr szComTool,MB_OK
				.else
					lea edi,HelpFile
					add edi,eax
					sub edi,4
					.if dword ptr [edi]=="plh." || dword ptr [edi]=="PLH."
						invoke ShellExecute,hWin,addr szOpen,addr szwinhlp32,addr HelpFile,0,0
						
					.elseif dword ptr [edi]=="mhc." || dword ptr [edi]=="MHC."
						invoke HtmlHelp,hMainDlg,addr HelpFile,0fh,0
						.if eax==0
							invoke wsprintf,addr buffer,addr szHelpPath,addr HelpFile
							invoke MessageBox,hMainDlg,addr buffer,addr szComTool,MB_OK
						.endif
						
					.endif
					
				.endif
				
			.elseif ax==IDM_Tut
				invoke GetModuleFileName,hInstance,addr buffer,sizeof buffer
				invoke lstrlen,addr buffer
				mov ecx,eax
				dec ecx
				lea edi,buffer
				add edi,ecx
				std
				mov al,"\"
				repne scasb
				cld
				inc edi
				inc edi
				mov byte ptr [edi],0
				invoke lstrcat,addr buffer,addr szComTut

				invoke HtmlHelp,0,addr buffer,0,0
				
			.elseif ax==IDM_About
				invoke DialogBoxParam,hInstance,IDD_DIALOG5,hWin,addr AboutDlgProc,0
				
			.endif
			
; Button ==========================================================================================
		.else
			mov edx,wParam
			shr edx,16
			.if dx==BN_CLICKED
				push eax
				invoke LoadCursor,0,IDC_WAIT
				invoke SetCursor,eax
				pop eax
				.if ax==IDC_BTN_CLASSES
					invoke ShowWindow,hLSV1,SW_HIDE
					invoke InsertColumns,2,addr szHeading1,50,addr szHeading6,150
					mov TypeKind,TKIND_DISPATCH
					invoke Classes,TKIND_DISPATCH,0,FALSE,FALSE 
					invoke ShowWindow,hLSV1,SW_SHOW
					
				.elseif ax==IDC_BTN_INTERFACES
					invoke ShowWindow,hLSV1,SW_HIDE
					invoke InsertColumns,2,addr szHeading1,50,addr szHeading10,150
					mov TypeKind,TKIND_INTERFACE
					invoke Classes,TKIND_INTERFACE,0,FALSE,FALSE 
					invoke ShowWindow,hLSV1,SW_SHOW
					
				.elseif ax==IDC_BTN_IIDs
					invoke ShowWindow,hLSV1,SW_HIDE
					invoke InsertColumns,3,addr szHeading1,50,addr szHeading8,150,addr szHeading9,300
					mov TypeKind,TKIND_DISPATCH
					invoke Classes,TKIND_DISPATCH,0,FALSE,FALSE 
					invoke ShowWindow,hLSV1,SW_SHOW
					
				.elseif ax==IDC_BTN_ENUMERATIONS
					invoke ShowWindow,hLSV1,SW_HIDE
					invoke InsertColumns,2,addr szHeading1,50,addr szHeading7,150
					mov TypeKind,TKIND_ENUM
					invoke Classes,TKIND_ENUM,0,FALSE,FALSE  
					invoke ShowWindow,hLSV1,SW_SHOW
					
				.elseif ax==IDC_BTN_Close
					invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
					
				.endif
				mov SortType,0
			.endif
		.endif
	
    .elseif uMsg == WM_NOTIFY
        mov edi,lParam
		assume edi:ptr NMHDR
		mov eax,[edi].hwndFrom
		.if eax==hLSV1
; Click on column header ===============================================================================
		    .if [edi].code == LVN_COLUMNCLICK
				.if [edi.NM_LISTVIEW].iSubItem==1
					invoke getColumnHeader,1,addr buffer3
					invoke checkColumnHeader,addr buffer3
					.if eax==TRUE 
						invoke LoadCursor,0,IDC_WAIT
						invoke SetCursor,eax
						invoke UpdatelParam
						invoke SendMessage,hLSV1,LVM_SORTITEMS,0,addr CompareFunc
						xor SortType,1
						invoke ImageList_LoadImage,hInstance,11000,16,0,08000FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
						invoke SendMessage,hHeader,HDM_SETIMAGELIST,0,eax
						mov hdi.imask,HDI_FORMAT or HDI_IMAGE
						mov hdi.fmt,HDF_IMAGE or HDF_STRING or HDF_BITMAP_ON_RIGHT
						.if SortType==0
							mov hdi.iImage,2
							invoke SendMessage,hHeader,HDM_SETITEM,1,ADDR hdi
						.else
							mov hdi.iImage,0
							invoke SendMessage,hHeader,HDM_SETITEM,1,ADDR hdi
						.endif
					.endif
				.endif
           
; RightClick on listview item ===============================================================================
;Column index=0 is the No column.
            .elseif [edi].code==NM_RCLICK
	             mov ecx,[edi.NM_LISTVIEW].iItem
	             .if ecx!=-1 
	             	push ecx
	                invoke getTextMatrix,ecx,1,addr buffer
	                pop ecx
	             	invoke getTextMatrix,ecx,2,addr buffer2
					invoke getColumnHeader,1,addr buffer3
					invoke lstrcmp,addr buffer3,addr szHeading2 ;cmp header with "TypeLib Name"
					.if eax==0 ;yes
						invoke DialogBoxParam,hInstance,IDD_DIALOG6,hWin,addr QuickSearchDlgProc,addr buffer
						.if ax==6
							shr eax,16
							mov edx,eax
							invoke QuickSearchSave,edx,addr buffer,addr buffer2
						.endif
						invoke OpenComponent,addr buffer2
						
					.endif
	             .endif
	             
; Click on listview item ===============================================================================
;Column index=0 is the No column.
            .elseif [edi].code==NM_CLICK
				mov ecx,[edi.NM_LISTVIEW].iItem
				.if ecx!=-1 
					push edi
					push ecx
	                invoke getTextMatrix,ecx,1,addr buffer
	                pop ecx
	                invoke getTextMatrix,ecx,2,addr buffer2
					invoke getColumnHeader,1,addr buffer3
					; ======================================================================================================================
					; All components are listed. Click on a line will list the interfaces
					;of the clicked component
					invoke lstrcmp,addr buffer3,addr szHeading2 ;cmp header with "TypeLib Name"
					.if eax==0 ;yes, listing the interfaces of the component
						.if flUnreg==TRUE 
							invoke wsprintf,addr buffer,addr szUnregComp,addr buffer2
							invoke ShellExecute,hWin,addr szOpen,addr szRegsvr32,addr buffer,0,0
							mov flUnreg,FALSE 
							jmp return
						.else
							invoke OpenComponent,addr buffer2
							assume edi:nothing 
							mov eax,TRUE 
							jmp return
						.endif
						
					.endif
					; ======================================================================================================================
					; Interfaces of a component are listed. Click will have no affect.
					invoke lstrcmp,addr buffer3,addr szHeading5 ;cmp header with "COMPONENT INTERFACES"
					.if eax==0
						assume edi:nothing 
						mov eax,TRUE 
						jmp return
					.endif
					; ======================================================================================================================
					; Classes or enumerations are listed. Click will get the members of the 
					; clicked class or enumeration.
					invoke lstrcmp,addr buffer3,addr szHeading6 ;cmp header with "CLASSES"
					push eax
					invoke lstrcmp,addr buffer3,addr szHeading7 ;cmp header with "ENUMERATIONS"
					pop ecx
					pop edi
					.if eax==0 || ecx==0
						push ecx
						push eax
						.if [edi.NM_LISTVIEW].iSubItem==1
							invoke LoadCursor,0,IDC_WAIT
							invoke SetCursor,eax
							invoke ShowWindow,hLSV1,SW_HIDE
							invoke wsprintf,addr printout,addr szHeading12,addr buffer
							pop eax
							pop ecx
							.if eax==0
								invoke InsertColumns,4,addr szHeading1,50,addr szHeading14,100,addr printout,200,\
									addr szHeading15,150
							.elseif ecx==0
								invoke InsertColumns,4,addr szHeading1,50,addr szHeading11,100,addr printout,200,\
									addr szHeading13,150
							.endif
							invoke Members,TypeKind,addr buffer,FALSE 
							invoke ShowWindow,hLSV1,SW_SHOW
						.endif
						assume edi:nothing 
						mov eax,TRUE  
						jmp return
					.endif
					; ======================================================================================================================
					; Members of a class are listed. Click on a pointer in column 3 will list the members of
					; the clicked class.
					invoke lstrcmp,addr buffer3,addr szHeading11 ;cmp header with "CLASS"
					.if eax==0 && [edi.NM_LISTVIEW].iSubItem==3
						invoke getTextMatrix,[edi.NM_LISTVIEW].iItem,3,addr buffer
						invoke lstrlen,addr buffer
						.if eax!=0
							lea edx,buffer
							add edx,eax
							.if byte ptr [edx-1]==")"
								mov byte ptr [edx-1],0
								lea edi,buffer
								xor eax,eax
								mov eax,"("
							@@:
								scasb
								je @F
								jmp @B
							@@:
								mov byte ptr[edi-1],0
								invoke wsprintf,addr buffer2,addr szExtInfo,addr [buffer+1],edi
								invoke MessageBox,0,addr buffer2,addr szComTool,MB_OK or MB_ICONINFORMATION

							.else
								invoke LoadCursor,0,IDC_WAIT
								invoke SetCursor,eax
								invoke ShowWindow,hLSV1,SW_HIDE
								invoke SendMessage,hLSV1,LVM_DELETEALLITEMS,0,0
								invoke Members,TypeKind,addr [buffer+1],FALSE 
								invoke ShowWindow,hLSV1,SW_SHOW
							.endif
						.endif
						assume edi:nothing 
						mov eax,TRUE  
						jmp return
					.endif
					; ======================================================================================================================
					; Members of a class are listed. Click on a class member in column2 will open the 
					; RadAsm dialog with Asm code.
					invoke lstrcmp,addr buffer3,addr szHeading11 ;cmp header with "CLASS"
					.if eax==0 && [edi.NM_LISTVIEW].iSubItem==2
						push edi
						.if hRichEditDLL==0
							invoke LoadLibrary,offset szRichEditDLL
							mov hRichEditDLL,eax
						.endif
						invoke getTextMatrix,[edi.NM_LISTVIEW].iItem,2,addr buffer
						invoke getTextMatrix,0,1,addr buffer2
						pop edi
						invoke getClassMemberCode,[edi.NM_LISTVIEW].iItem,addr buffer,addr buffer2,FALSE 
						
						invoke DialogBoxParam,hInstance,IDD_DIALOG2,hMainDlg,addr RadAsmDlgProc,addr CodeStr
						
					.endif
					; ======================================================================================================================
					; Members of a class IIDs are listed. Click on a line will open the 
					; RadAsm dialog with Asm code.
					invoke lstrcmp,addr buffer3,addr szHeading8 ;cmp header with "IID_"
					.if eax==0
						.if hRichEditDLL==0
							invoke LoadLibrary,offset szRichEditDLL
							mov hRichEditDLL,eax
						.endif
						invoke getTextMatrix,[edi.NM_LISTVIEW].iItem,1,addr buffer
						invoke getTextMatrix,[edi.NM_LISTVIEW].iItem,2,addr buffer2
						invoke asmCLSID,addr buffer2
						invoke wsprintf,addr printout,addr szIID,addr buffer,addr buffer2
						invoke DialogBoxParam,hInstance,IDD_DIALOG2,hMainDlg,addr RadAsmDlgProc,addr printout
						
					.endif
					; ======================================================================================================================
					; Members of a class ENUMARATION are listed. Click on a line will open the 
					; RadAsm dialog with the equals.
					invoke lstrcmp,addr buffer3,addr szHeading14 ;cmp header with "ENUMERATION"
					.if eax==0
						.if hRichEditDLL==0
							invoke LoadLibrary,offset szRichEditDLL
							mov hRichEditDLL,eax
						.endif
						invoke getEnumCode
						invoke DialogBoxParam,hInstance,IDD_DIALOG2,hMainDlg,addr RadAsmDlgProc,addr CodeStr
	            	.endif
	            .endif
			.endif
		.endif
		assume edi:nothing 
		
	.elseif uMsg==WM_SIZE
		mov eax,lParam
		mov edx,eax
		and eax,0FFFFh
		shr edx,16
		sub edx,65
		mov pos,edx
		invoke MoveWindow,hLSV1,0,0,eax,pos,TRUE
		add pos,8
		invoke MoveWindow,hBTN6,6,pos,106,25,TRUE		
		invoke MoveWindow,hBTN10,117,pos,106,25,TRUE		
		invoke MoveWindow,hBTN9,228,pos,106,25,TRUE	
		invoke MoveWindow,hBTN8,339,pos,106,25,TRUE		
		invoke MoveWindow,hBTN7,450,pos,106,25,TRUE	
		invoke GetDlgItem,hMainDlg,IDC_SBR1
		mov hSBR1,eax
		invoke MoveWindow,hSBR1,0,0,0,0,TRUE
		;mov eax,TRUE   
		jmp return
		
	.elseif uMsg==WM_CLOSE
		
		.if pTypeInfos!=0
			invoke IDispRelease,addr pTypeInfos
		.endif
		.if pTypeLibInfo!=0
			invoke IDispRelease,addr pTypeLibInfo
		.endif
		invoke EndDialog,hWin,0
		.if hRichEditDLL!=0
			invoke FreeLibrary,hRichEditDLL
		.endif
		
		invoke ODBCDisconnect,hWin
		invoke CoUninitialize
		mov hMainDlg,0
	.else
		mov eax,FALSE
		jmp return
	.endif
	mov eax,TRUE
; ======================================================================================================================
	
return:
	push ebx
	pop esi
	pop edi
	pop edx
	_finally
	ret

Snippets:
	push edx
	.if hRichEditDLL==0
		invoke LoadLibrary,offset szRichEditDLL
		mov hRichEditDLL,eax
	.endif
	pop edx
	invoke getCodeSnippet,edx,addr buffer
	mov edx,lpHStruct
	invoke DialogBoxParam,hInstance,IDD_DIALOG2,[edx.ADDINHANDLES].hEdit,addr RadAsmDlgProc,addr buffer
	retn

Macros:
	push edx
	.if hRichEditDLL==0
		invoke LoadLibrary,offset szRichEditDLL
		mov hRichEditDLL,eax
	.endif
	pop edx
	invoke getMacros,edx,addr buffer
	mov edx,lpHStruct
	invoke DialogBoxParam,hInstance,IDD_DIALOG2,[edx.ADDINHANDLES].hEdit,addr RadAsmDlgProc,addr buffer
	retn

MainDlgProc endp

ButtonState proc State:BOOL
	LOCAL mState:BOOL
	
	_try offset ED_04 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
	push ebx

; ======================================================================================================================
	invoke GetDlgItem,hMainDlg,IDC_BTN_CLASSES
	invoke EnableWindow,eax,State
	invoke GetDlgItem,hMainDlg,IDC_BTN_INTERFACES
	invoke EnableWindow,eax,State
	invoke GetDlgItem,hMainDlg,IDC_BTN_IIDs
	invoke EnableWindow,eax,State
	invoke GetDlgItem,hMainDlg,IDC_BTN_ENUMERATIONS
	invoke EnableWindow,eax,State
	.if State==TRUE
		mov mState,MF_ENABLED
	.else
		mov mState,MF_GRAYED
	.endif
	invoke GetMenu,hMainDlg
	invoke EnableMenuItem,eax,IDM_VBbrowser,mState
; ======================================================================================================================

return:
	pop ebx
	pop esi
	pop edi
	pop edx
	_finally
	ret

ButtonState endp

asmCLSID proc pText:dword
; Converting {59191DA1-EA47-11CE-A51F-00AA0061507F}
; to {059191DA1h,0EA47h,011CEh,{0A5h,01Fh,000h,0AAh,000h,061h,050h,07Fh}}

	LOCAL buffer[2048]:byte
	LOCAL buffer2[2048]:byte
	
	_try offset ED_03 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
	push ebx

; ======================================================================================================================
	invoke lstrcpy,addr buffer,pText
	lea esi,buffer	;from
	lea edi,buffer2	;to
	movsb	;"{
	mov byte ptr [edi],"0"	;"{0
	inc edi
	movsd	;"{059191DA1
	movsd	;"{059191DA1
	mov dword ptr [edi],"-0,h"	;"{059191DA1h,0-
	add edi,3
	inc esi
	movsd	;"{059191DA1h,0EA47
	mov dword ptr [edi],"-0,h"	;"{059191DA1h,0EA47h,0-
	add edi,3
	inc esi
	movsd	;"{059191DA1h,0EA47h,011CE
	mov dword ptr [edi],"0{,h"	;"{059191DA1h,0EA47h,011CEh,{0
	add edi,4
	inc esi
	movsw	;"{059191DA1h,0EA47h,011CEh,{0A5
	mov dword ptr [edi],"-0,h"	;"{059191DA1h,0EA47h,011CEh,{0A5h,0-
	add edi,3
	movsw	;"{059191DA1h,0EA47h,011CEh,{0A5h,01F
	mov dword ptr [edi],"-0,h"	;"{059191DA1h,0EA47h,011CEh,{0A5h,01Fh,0-
	add edi,3
	inc esi
	movsw	;"{059191DA1h,0EA47h,011CEh,{0A5h,01Fh,000
	mov dword ptr [edi],"-0,h"	;"{059191DA1h,0EA47h,011CEh,{0A5h,01Fh,000h,0-
	add edi,3
	movsw	;"{059191DA1h,0EA47h,011CEh,{0A5h,01Fh,000h,0AA
	mov dword ptr [edi],"-0,h"	;"{059191DA1h,0EA47h,011CEh,{0A5h,01Fh,000h,0AAh,0-
	add edi,3
	movsw	;"{059191DA1h,0EA47h,011CEh,{0A5h,01Fh,000h,0AAh,000
	mov dword ptr [edi],"-0,h"	;"{059191DA1h,0EA47h,011CEh,{0A5h,01Fh,000h,0AAh,000h,0-
	add edi,3
	movsw	;"{059191DA1h,0EA47h,011CEh,{0A5h,01Fh,000h,0AAh,000h,061
	mov dword ptr [edi],"-0,h"	;"{059191DA1h,0EA47h,011CEh,{0A5h,01Fh,000h,0AAh,000h,061h,0-
	add edi,3
	movsw	;"{059191DA1h,0EA47h,011CEh,{0A5h,01Fh,000h,0AAh,000h,061h,050
	mov dword ptr [edi],"-0,h"	;"{059191DA1h,0EA47h,011CEh,{0A5h,01Fh,000h,0AAh,000h,061h,050h,0-
	add edi,3
	movsw	;"{059191DA1h,0EA47h,011CEh,{0A5h,01Fh,000h,0AAh,000h,061h,050h,07F
	mov dword ptr [edi],"-}}h"	;"{059191DA1h,0EA47h,011CEh,{0A5h,01Fh,000h,0AAh,000h,061h,050h,07Fh}}
	add edi,3
	mov byte ptr [edi],0
	invoke lstrcpy,pText,addr buffer2
	
; ======================================================================================================================

return:
	pop ebx
	pop esi
	pop edi
	pop edx
	_finally
	mov eax,TRUE
	ret

asmCLSID endp

FileOpenDlg proc hParent:DWORD,pTitle:DWORD,pFilter:DWORD,pFileName:dword
	LOCAL ofn:OPENFILENAME
	
	_try offset ED_12 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
	push ebx

; ======================================================================================================================
    invoke RtlZeroMemory,addr ofn,sizeof ofn
    invoke RtlZeroMemory,pFileName,1024
    mov ofn.lStructSize,sizeof OPENFILENAME
    push hParent
    pop ofn.hWndOwner
    push hInstance
    pop ofn.hInstance
    push pFilter
    pop ofn.lpstrFilter
    mov eax,pFileName
    mov ofn.lpstrFile,eax
    mov ofn.nMaxFile,1024
    push pTitle
    pop ofn.lpstrTitle
    mov ofn.Flags,OFN_EXPLORER or OFN_FILEMUSTEXIST or OFN_LONGNAMES
    invoke GetOpenFileName,addr ofn
; ======================================================================================================================

return:
	pop ebx
	pop esi
	pop edi
	pop edx
	_finally
    ret

FileOpenDlg endp


