ODBCConnect proc hWin:DWORD
	LOCAL buffer[256]:byte
	LOCAL Conn[256]:byte
	
	_try offset ED_33 ;address of frame-based exception director
	
	push edx
	push edi
	push esi

; ======================================================================================================================
	;Allocate a handle of an environment
	invoke SQLAllocHandle,SQL_HANDLE_ENV,SQL_NULL_HANDLE,addr hEnv
	.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
		
		;Set attributes that govern aspects of environments
		invoke SQLSetEnvAttr,hEnv,SQL_ATTR_ODBC_VERSION,SQL_OV_ODBC3,0
		.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
			
			;Allocate a handle of a connection
			invoke SQLAllocHandle,SQL_HANDLE_DBC,hEnv,addr hConn
			.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
				invoke GetModuleFileName,hInstance,addr buffer,sizeof buffer
				invoke lstrlen,addr buffer
				mov ecx,eax
				dec ecx
				lea edi,buffer
				add edi,ecx
				std
				mov al,"\"
				repne scasb
				cld
				inc edi
				inc edi
				mov byte ptr [edi],0
				invoke wsprintf,addr Conn,addr ConnectString,addr buffer
				
				;Establish a connection to Com.mdb
				invoke SQLDriverConnect,hConn,hWin,addr Conn,sizeof Conn,0,0,0,SQL_DRIVER_COMPLETE				
				.if ax!=SQL_SUCCESS
					invoke SQLFreeHandle,SQL_HANDLE_DBC,hConn
					invoke SQLFreeHandle,SQL_HANDLE_ENV,hEnv
				.endif
			.else
				invoke SQLFreeHandle,SQL_HANDLE_ENV,hEnv
			.endif
		.else
			invoke SQLFreeHandle,SQL_HANDLE_ENV,hEnv
		.endif
	.else
	.endif
; ======================================================================================================================

return:
	pop esi
	pop edi
	pop edx
	_finally
	ret
	
ODBCConnect endp

ODBCDisconnect proc hWin:DWORD

	_try offset ED_34 ;address of frame-based exception director
	
; ======================================================================================================================
	invoke SQLDisconnect,hConn
	invoke SQLFreeHandle,SQL_HANDLE_DBC,hConn
	invoke SQLFreeHandle,SQL_HANDLE_ENV,hEnv
; ======================================================================================================================

return:
	_finally
	ret
	
ODBCDisconnect endp






