Classes proc TKIND:dword,pText:dword,memb:BOOL,browser:BOOL
;Listing classes such as Class objects, enumerations and interfaces
;Get pTypeInfos and pTypeInfo of class
	LOCAL pTypeInfo:dword
	
	LOCAL number:dword
	LOCAL x:dword
	LOCAL TypeKinds:dword
	LOCAL pWideAllocStr:dword
	LOCAL buffer[2048]:byte
	LOCAL flag:BOOL
	
	_try offset ED_07 ;address of frame-based exception director

	push edx
	push edi
	push esi
	
; ======================================================================================================================
	mov pTypeInfo,0
	
	;IID_ CLSID values executed?
	invoke getColumnHeader,1,addr buffer
	invoke lstrcmp,addr buffer,addr szHeading8 ;compare heading with "IID_"
	.if eax==0
		mov flag,TRUE
	.else
		mov flag,FALSE 
	.endif
	
;Set TI = T.TypeInfos
	mov eax,pTypeLibInfo
	mov edx,dword ptr [eax]
	push offset pTypeInfos  ;ptr to ptr to function: TypeInfos
	push pTypeLibInfo
	;call _TypeLibInfo.get_TypeInfos
	call dword ptr [edx+66*4]
	.if eax==S_OK
	
;TI.Count
		mov eax,pTypeInfos
		mov edx,dword ptr [eax]
		lea eax,number
		push eax ;ptr/VT_I2/
		push pTypeInfos
		;call TypeInfos.get_Count
		call dword ptr [edx+10*4]
		.if eax==S_OK
			and number,0ffffh
			xor ecx,ecx
			mov x,0
			.while ecx<=number
				push ecx
				
;TI(i)
				mov eax,pTypeInfos
				mov edx,dword ptr [eax]
				lea eax,pTypeInfo
				push eax  ;ptr to ptr to function: TypeInfo
				;Params( Index)
				mov eax,ecx
				inc eax
				push eax
				push pTypeInfos
				;call TypeInfos.get_Item
				call dword ptr [edx+11*4]
				.if eax==S_OK
				
;TI(i).TypeKind
					mov eax,pTypeInfo
					mov edx,dword ptr [eax]
					lea eax,TypeKinds
					push eax
					push pTypeInfo
					;call TypeInfo.get_TypeKind
					call dword ptr [edx+26*4]
					.if eax==S_OK
						mov eax,TypeKinds
						;TypeKinds gives ClassObject, Enumeration or Interface
						.if eax==TKIND
						
;TI(i).Name
							mov eax,pTypeInfo
							mov edx,dword ptr [eax]
							lea eax,pWideAllocStr
							push eax ;ptr/VT_BSTR/
							push pTypeInfo
							;call TypeInfo.get_Name
							call dword ptr [edx+9*4]
							.if eax==S_OK
								invoke WideCharToMultiByte,CP_ACP,0,pWideAllocStr,-1,\
									addr buffer,sizeof buffer,0,0
								invoke SysFreeString,pWideAllocStr

;;VBBrowser
								.if browser==TRUE 
									invoke SendMessage,hLST1,LB_ADDSTRING,0,addr buffer
									jmp @F
								.endif

								mov eax,memb
								.if eax==FALSE ;Listing all classes
									invoke AddListViewItem,x
									invoke putTextMatrix,x,1,addr buffer
									.if flag==TRUE
									
;TI(i).Guid
										mov eax,pTypeInfo
										mov edx,dword ptr [eax]
										lea eax,pWideAllocStr
										push eax  ;ptr/VT_BSTR/
										push pTypeInfo
										;call TypeInfo.get_GUID
										call dword ptr [edx+10*4]
										.if eax==S_OK
											invoke WideCharToMultiByte,CP_ACP,0,pWideAllocStr,-1,\
												addr buffer,sizeof buffer,0,0
											invoke SysFreeString,pWideAllocStr
											invoke putTextMatrix,x,2,addr buffer
										.endif
									.endif
									inc x
								.else 
									;Searching a named class from either ClassObject, 
									;Enumeration or Interface in order to listing the class
									;members.
									invoke lstrcmp,addr buffer,pText
									.if eax==0
										jmp return
									.endif
									invoke lstrcmp,addr [buffer+1],pText
									.if eax==0
										;Change to underscore again
										invoke lstrcpy,pText,addr buffer
										jmp return
									.endif
								.endif
							.endif
						.endif
					.endif
					invoke IDispRelease,addr pTypeInfo
				.endif
@@:
				pop ecx
				inc ecx
			.endw
		.endif
	.endif
	mov eax,TRUE
; ======================================================================================================================

return:
	pop esi
	pop edi
	pop edx
	_finally
	ret

Classes endp