InsertColumns proc c cCol:dword,Col:vararg
	LOCAL number:dword
	LOCAL lvc:LV_COLUMN
	LOCAL hdi:HD_ITEM
	LOCAL buffer[128]:byte
	
	_try offset ED_27 ;address of frame-based exception director
	
	push edx
	push edi
	push esi

; ======================================================================================================================
	invoke ImageList_Create,16,16,ILC_MASK or ILC_COLOR24,1,10
	mov hIml,eax


	invoke SendMessage,hLSV1,LVM_DELETEALLITEMS,0,0
	xor eax,eax
	mov eax,TRUE 
	.while eax==TRUE 
		push ecx
		invoke SendMessage,hLSV1,LVM_DELETECOLUMN,0,0
	.endw
	invoke SendMessage,hLSV1,LVM_SETEXTENDEDLISTVIEWSTYLE, 0,\
		LVS_EX_FULLROWSELECT or LVS_EX_GRIDLINES

	mov number,0
	mov ecx,cCol
	.while number<ecx
		push ecx
		mov lvc.imask,LVIF_IMAGE or LVCF_TEXT or LVCF_WIDTH
		mov ecx,number
		mov eax,dword ptr [Col+ecx*8]
		mov lvc.pszText,eax
		mov eax,dword ptr [Col+4+ecx*8]
		mov lvc.lx,eax
		invoke SendMessage,hLSV1,LVM_INSERTCOLUMN,number,addr lvc
		inc number
		pop ecx
	.endw
	
	invoke getColumnHeader,1,addr buffer
	invoke checkColumnHeader,addr buffer
	.if eax==TRUE 
		invoke SendMessage,hLSV1,LVM_GETHEADER,0,0
		mov hHeader,eax
		invoke ImageList_LoadImage,hInstance,11000,16,0,08000FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
		invoke SendMessage,hHeader,HDM_SETIMAGELIST,0,eax
		mov hdi.imask,HDI_FORMAT or HDI_IMAGE
		mov hdi.fmt,HDF_IMAGE or HDF_STRING or HDF_BITMAP_ON_RIGHT
		mov hdi.iImage,2
		invoke SendMessage,hHeader,HDM_SETITEM,1,ADDR hdi
	.endif
; ======================================================================================================================

return:
	pop esi
	pop edi
	pop edx
	_finally
	ret

InsertColumns endp

getColumnHeader proc Col:dword,pText:dword
	LOCAL lvc:LV_COLUMN
	
	_try offset ED_16 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
	push ecx

; ======================================================================================================================
	mov lvc.imask,LVCF_TEXT
	push pText
	pop lvc.pszText
	mov lvc.cchTextMax,2048
	invoke SendMessage,hLSV1,LVM_GETCOLUMN,Col,addr lvc
; ======================================================================================================================

return:
	pop ecx
	pop esi
	pop edi
	pop edx
	_finally
	ret

getColumnHeader endp

checkColumnHeader proc pText:dword
	
	_try offset ED_05 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
	push ecx

; ======================================================================================================================
	invoke lstrcmp,pText,addr szHeading2 ;cmp header with "TypeLib Name"
	.if eax!=0 ;No
		invoke lstrcmp,pText,addr szHeading6 ;cmp header with "Classes"
		.if eax!=0 ;No
			invoke lstrcmp,pText,addr szHeading10 ;cmp header with "Interfaces"
			.if eax!=0 ;No
				invoke lstrcmp,pText,addr szHeading8 ;cmp header with "IID_"
				.if eax!=0 ;No
					invoke lstrcmp,pText,addr szHeading7 ;cmp header with "Enumerations"
					.if eax!=0 ;No
						mov eax,FALSE 
						jmp return
					.endif
				.endif
			.endif
		.endif
	.endif
	mov eax,TRUE
; ======================================================================================================================

return:
	pop ecx
	pop esi
	pop edi
	pop edx
	_finally
	ret

checkColumnHeader endp

