ExceptionHandler proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD,pText:DWORD
	LOCAL buffer[128]:byte
	
	;======================
	lea eax,pExceptionRecord
	mov eax,[eax]
	invoke wsprintf,addr buffer,addr szExceptionText,pText,[eax.EXCEPTION_RECORD.ExceptionAddress]
	invoke MessageBox,0,addr buffer,0,MB_ICONERROR or MB_OK
	;======================

	mov eax, pStackFrame
	push [eax+8]		; PrevEsp
	push [eax+12]		; PrevEbp
	push [eax+16]		; SafeOffset

	mov eax, pContext
	assume eax:ptr CONTEXT
	pop [eax].regEip	; SafeOffset
	pop [eax].regEbp	; PrevEbp
	pop [eax].regEsp	; PrevEsp
	
    xor eax, eax 
    ret 

ExceptionHandler endp

ED_001 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD

	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,CTEXT("DllEntry")
	ret
ED_001 endp

ED_002 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD

	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,CTEXT("InstallDll")
	ret
ED_002 endp

ED_003 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD

	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,CTEXT("DllProc")
	ret
ED_003 endp

ED_01 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;AboutDlgProc
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc01,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_01 endp

ED_02 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;AddListViewItem
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc02,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_02 endp

ED_03 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;asmCLSID
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc03,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_03 endp

ED_04 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;ButtonState
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc04,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_04 endp

ED_05 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;checkColumnHeader
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc05,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_05 endp

ED_06 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;CheckLCID
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc06,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_06 endp

ED_07 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;Classes
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc07,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_07 endp

ED_08 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;CompareFunc
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc08,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_08 endp

ED_09 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;ComponentInterfaces
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc09,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_09 endp

ED_10 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;EditWndProc
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc10,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_10 endp

ED_11 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;EnumValue
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc11,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_11 endp

ED_12 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;FileOpenDlg
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc12,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_12 endp

ED_13 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;getArgumentTypesName
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc13,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_13 endp

ED_14 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;getClassMemberCode
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc14,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_14 endp

ED_15 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;getCodeSnippet
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc15,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_15 endp

ED_16 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;getColumnHeader
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc16,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_16 endp

ED_17 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;getEnumCode
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc17,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_17 endp

ED_18 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;getInvokeType
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc18,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_18 endp

ED_19 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;getMacros
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc19,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_19 endp

ED_20 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;getParameterCode
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc20,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_20 endp

ED_21 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;getParameterInfo
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc21,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_21 endp

ED_22 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;getParameters
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc22,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_22 endp

ED_23 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;getTextMatrix
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc23,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_23 endp

ED_24 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;getVarTypeName
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc24,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_24 endp

ED_25 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;IDispRelease
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc25,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_25 endp

ED_26 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;infoDlgProc
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc26,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_26 endp

ED_27 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;InsertColumns
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc27,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_27 endp

ED_28 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;ListLib
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc28,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_28 endp

ED_29 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;LST1WndProc
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc29,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_29 endp

ED_30 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;LST2WndProc
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc30,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_30 endp

ED_31 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;MainDlgProc
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc31,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_31 endp

ED_32 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;Members
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc32,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_32 endp

ED_33 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;ODBCConnect
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc33,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_33 endp

ED_34 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;ODBCDisconnect
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc34,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_34 endp

ED_35 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;OpenComponent
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc35,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_35 endp

ED_36 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;putTextMatrix
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc36,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_36 endp

ED_37 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;QuickSearch
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc37,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_37 endp

ED_38 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;QuickSearchDlgProc
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc38,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_38 endp

ED_39 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;QuickSearchSave
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc39,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_39 endp

ED_40 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;RadAsmDlgProc
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc40,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_40 endp

ED_41 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;ReturnType
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc41,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_41 endp

ED_42 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;String2Dword
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc42,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_42 endp

ED_43 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;UpdatelParam
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc43,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_43 endp

ED_44 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;VariantDlgProc
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc44,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_44 endp

ED_45 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;VariantHelp
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc45,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_45 endp

ED_46 proc pExceptionRecord:DWORD,pStackFrame:DWORD,pContext:DWORD
	;VBBrowserProc
	LOCAL string[128]:byte
	invoke LoadString,hInstance,Exc46,addr string,sizeof string
	invoke ExceptionHandler,pExceptionRecord,pStackFrame,pContext,addr string
	ret
ED_46 endp

