ListLib proc Index:dword,Sorted:BOOL,QSearch:dword
;Searching the registry for components.
	LOCAL x:dword
	LOCAL hHK1:dword
	LOCAL hHK2:dword
	LOCAL hHK3:dword
	LOCAL hHK4:dword
	LOCAL lpGUID[128]:byte
	LOCAL lpName[128]:byte
	LOCAL lpValue[128]:byte
	LOCAL lpPath[128]:byte
	LOCAL cBuff:dword
	
	_try offset ED_28 ;address of frame-based exception director
	
	push edx
	push edi
	push esi

; ======================================================================================================================
	invoke SendMessage,hLSV1,LVM_DELETEALLITEMS,0,0

	invoke RegOpenKeyEx,HKEY_CLASSES_ROOT,addr szTypeLib,0,KEY_READ,addr hHK1
	.if eax==ERROR_SUCCESS
		xor ecx,ecx
		mov x,0
		.while eax!=ERROR_NO_MORE_ITEMS
			push ecx
			invoke RegEnumKey,hHK1,ecx,addr lpGUID,sizeof lpGUID
			push eax
			.if eax==ERROR_SUCCESS
				invoke RegOpenKeyEx,hHK1,addr lpGUID,0,KEY_READ,addr hHK2
				.if eax==ERROR_SUCCESS
					xor ecx,ecx
					
					.while eax!=ERROR_NO_MORE_ITEMS
						push ecx
						invoke RegEnumKey,hHK2,ecx,addr lpName,sizeof lpName
						push eax
						.if eax==ERROR_SUCCESS
							mov cBuff,sizeof lpValue
							invoke RegQueryValue,hHK2,addr lpName,addr lpValue,addr cBuff
							invoke RegOpenKeyEx,hHK2,addr lpName,0,KEY_READ,addr hHK3
							invoke RegOpenKeyEx,hHK3,addr szZero,0,KEY_READ,addr hHK4
							mov cBuff,sizeof lpPath
							invoke RegQueryValue,hHK4,addr szWin32,addr lpPath,addr cBuff
							
							;Write to ListView
							invoke AddListViewItem,x
							invoke putTextMatrix,x,1,addr lpValue
							invoke putTextMatrix,x,2,addr lpPath
							invoke putTextMatrix,x,3,addr lpGUID
						    inc x
						.endif
						pop eax
						pop ecx
						inc ecx
					.endw
				.endif
			.endif
			pop eax
			pop ecx
			inc ecx
		.endw
	.endif
	invoke RegCloseKey,hHK1
 	invoke RegCloseKey,hHK2
	invoke RegCloseKey,hHK3
	invoke RegCloseKey,hHK4
; ======================================================================================================================

return:
	pop esi
	pop edi
	pop edx
	_finally
	ret

ListLib endp


