Par macro v1:=<VT_I4>,v2:=<0> 
	if @InStr(1,v1,<VT_R8>) NE 0
		push    0
		push    DWORD PTR [v2]
		push    0
		push    v1
	else
		push    0
		push    v2
		push    0
		push    v1
	endif
endm

NoPar macro Num:=<1>
	LOCAL a1, a2
	a1 equ <Num>
	a2 = 0
	while a1 ne a2
		push 0
		push DISP_E_PARAMNOTFOUND
		push 0
		push VT_ERROR
        a2 = a2 + 1
	endm
endm	

CTEXT macro text:vararg 
    LOCAL TxtName 
    .data 
     TxtName byte text,0 
    .code 
  exitm <addr TxtName> 
endm

_try macro address
	;tousch the stack
	mov eax,ebp 
	.while eax>esp 
		sub eax,4 
		mov dword ptr [eax],0 
	.endw 
	;-try
	push return 		;address of safe place after guarded code
	push ebp 			;stack frame
	push esp
	assume fs:nothing
	push address 		;address of frame-based exception director
	push fs:[0]			;address of next error structure
	mov fs:[0], esp 	;save the error address
endm

_finally macro
	;_finally
	assume fs:nothing
	pop fs:[0] 	;restore next error structure
	add esp, 4 	;adjust stack
endm

