getParameterCode proc pClass:dword,pText:dword
	LOCAL pParameters:dword
	
	LOCAL number:dword
	LOCAL buffer[256]:byte
	LOCAL parametersInfo[256]:byte
	LOCAL i:dword
	
	_try offset ED_20 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
	push ebx

; ======================================================================================================================
	mov pParameters,0
;Set TIMP = TIM(i).Parameters
	mov eax,pClass ;pMemberInfo
	mov edx,dword ptr [eax]
	lea eax,pParameters
	push eax  ;ptr to ptr to function: Parameters
	push pClass
	;call MemberInfo.get_Parameters
	call dword ptr [edx+13*4]
	.if eax==S_OK
	
;TIMP.Count
		mov eax,pParameters
		mov edx,dword ptr [eax]
		lea eax,number
		push eax
		push pParameters
		;call Parameters.get_Count
		call dword ptr [edx+11*4]
		.if eax==S_OK
			and number,0ffffh
			.if number!=0
				invoke RtlZeroMemory,addr Buffer,sizeof Buffer
				invoke lstrcpy,addr parametersInfo,addr szParamsS
				;InfoString===============================
				invoke wsprintf,addr buffer,addr szInfo5,number
				invoke lstrcat,addr InfoStr,addr buffer
				invoke lstrcat,addr InfoStr,addr szInfo6
				;InfoString===============================
				mov counter,0
				push number
				pop i
				mov ecx,1
				.while ecx<=number
					push ecx
					;commented parameter text
					.if number>1 && ecx>1
						invoke lstrcat,addr parametersInfo,addr szComma
					.endif
					pop ecx
					push ecx
					invoke getParameterInfo,pParameters,ecx,addr buffer
					.if eax==TRUE
						invoke lstrcat,addr parametersInfo,addr buffer
					.endif
					
					;code
					invoke getParameters,pParameters,i ;,addr buffer
					
					dec i
					pop ecx
					inc ecx
				.endw
				invoke lstrcat,addr parametersInfo,addr szParamsE
				invoke lstrcat,addr parametersInfo,addr Buffer
				invoke lstrcpy,pText,addr parametersInfo
				mov eax,2
				jmp return
			.else
				mov eax,1
				jmp return
			.endif
		.endif
		invoke IDispRelease,pParameters
	.endif
	mov eax,1 
; ======================================================================================================================
return:
	pop ebx
	pop esi
	pop edi
	pop edx
	_finally
	ret

getParameterCode endp

getParameterInfo proc pClass:dword,index:dword,pText:dword
;Commented parameter text
	LOCAL pParameterInfo:dword
	
	LOCAL flag:BOOL
	LOCAL pWideAllocStr:dword
	LOCAL buffer[256]:byte
	LOCAL buffer2[256]:byte
	LOCAL ParamFlag:dword
	
	_try offset ED_21 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
	push ebx

; ======================================================================================================================
	mov pParameterInfo,0
	
;TIMP(i)
	mov eax,pClass ;pParameters
	mov edx,dword ptr [eax]
	lea eax,pParameterInfo
	push eax  ;ptr to ptr to function: ParameterInfo
	;Params( Index)
	push index
	push pClass
	;call Parameters.get_Item
	call dword ptr [edx+10*4]
	.if eax==S_OK
	
;TIMP(i).Optional
		mov eax,pParameterInfo
		mov edx,dword ptr [eax]
		lea eax,flag
		push eax
		push pParameterInfo
		;call ParameterInfo.get_Optional
		call dword ptr [edx+10*4]
		.if eax==S_OK
		
;TIMP(i),Name
			mov eax,pParameterInfo
			mov edx,dword ptr [eax]
			lea eax,pWideAllocStr
			push eax
			push pParameterInfo
			;call ParameterInfo.get_Name
			call dword ptr [edx+9*4]
			.if eax==S_OK
				invoke WideCharToMultiByte,CP_ACP,0,pWideAllocStr,-1,\
					addr buffer,sizeof buffer,0,0
				invoke SysFreeString,pWideAllocStr
				and flag,0ffffh
				.if flag==VARIANT_TRUE ;optional parameter
					invoke wsprintf,addr buffer2,addr szOptional,addr buffer
					invoke lstrcpy,pText,addr buffer2
					invoke lstrcat,addr InfoStr,addr szInfo7
					invoke lstrcat,addr InfoStr,addr buffer
					invoke lstrcat,addr InfoStr,addr szCRLF
				.else ;not optional parameter
					mov eax,pParameterInfo
					mov edx,dword ptr [eax]
					lea eax,ParamFlag
					push eax
					push pParameterInfo
					;call ParameterInfo.get_Flags
					call dword ptr [edx+17*4]
					.if eax==S_OK 
						.if ParamFlag==1
							invoke lstrcat,addr InfoStr,addr szInfo8
							invoke lstrcat,addr InfoStr,addr buffer
							invoke lstrcat,addr InfoStr,addr szCRLF
						.elseif ParamFlag==2
							invoke lstrcat,addr InfoStr,addr szInfo9
							invoke lstrcat,addr InfoStr,addr buffer
							invoke lstrcat,addr InfoStr,addr szCRLF
						.endif
					.endif
					invoke lstrcpy,pText,addr buffer
				.endif
			.endif
		.endif
		invoke IDispRelease,addr pParameterInfo
		mov eax,TRUE 
		jmp return
	.endif
	mov eax,FALSE
; ======================================================================================================================

return:
	pop ebx
	pop esi
	pop edi
	pop edx
	_finally
	ret

getParameterInfo endp

getParameters proc pClass:dword,index:dword ;,pText:dword
	LOCAL pParameterInfo:dword
	LOCAL pVarTypeInfo:dword
	
	LOCAL flag:BOOL
	LOCAL VarType:dword
	LOCAL pVarName:dword
	LOCAL buffer[256]:byte
	LOCAL x:dword
	
	_try offset ED_22 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
	push ebx

; ======================================================================================================================
	mov pParameterInfo,0
	mov pVarTypeInfo,0
	
;TIMP(i)
	mov eax,pClass ;pParameters
	mov edx,dword ptr [eax]
	lea eax,pParameterInfo
	push eax  ;ptr to ptr to function: ParameterInfo
	;Params( Index)
	push index
	push pClass
	;call Parameters.get_Item
	call dword ptr [edx+10*4]
	.if eax==S_OK
	
;TIMP(i).Optional
		mov eax,pParameterInfo
		mov edx,dword ptr [eax]
		lea eax,flag
		push eax
		push pParameterInfo
		;call ParameterInfo.get_Optional
		call dword ptr [edx+10*4]
		.if eax==S_OK
			and flag,0ffffh
			.if flag==VARIANT_TRUE ;optional parameter
				inc counter
				
			.else ;not optional parameter
				
;TIMP(i).VarTypes
				mov eax,pParameterInfo
				mov edx,dword ptr [eax]
				lea eax,pVarTypeInfo
				push eax  ;ptr to ptr to function: VarTypeInfo
				push pParameterInfo
				;call ParameterInfo.get_VarTypeInfo
				call dword ptr [edx+12*4]
				.if eax==S_OK
				
;TIMP(i).VarType
					mov eax,pVarTypeInfo
					mov edx,dword ptr [eax]
					lea eax,VarType
					push eax
					push pVarTypeInfo
					;call VarTypeInfo.get_VarType
					call dword ptr [edx+16*4]
					.if eax==S_OK
						.if counter!=0
							invoke wsprintf,addr buffer,addr szNoPar,counter
							invoke lstrcat,addr Buffer,addr buffer
						.endif
						invoke getVarTypeName,VarType,addr pVarName
						invoke wsprintf,addr buffer,addr szRadCode3_1,pVarName
						invoke lstrcat,addr Buffer,addr buffer
						mov counter,0
					.endif
				.endif
				invoke IDispRelease,addr pVarTypeInfo
			.endif
		.endif
		invoke IDispRelease,addr pParameterInfo
	.endif
; ======================================================================================================================
return:
	pop ebx
	pop esi
	pop edi
	pop edx
	_finally
	ret

getParameters endp











