RadAsmDlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL rect:RECT
	LOCAL pos:dword
	LOCAL buffer[4096]:byte
	LOCAL hClipboard:dword

	_try offset ED_40 ;address of frame-based exception director
	
	push edx
	push edi
	push esi

; ======================================================================================================================
	.if uMsg==WM_INITDIALOG
		push hWin
		pop hRadAsmDlg

		invoke SetWindowPos,hMainDlg,HWND_BOTTOM,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE
		
		invoke LoadIcon,hInstance,IDI_ACTIVEX
		invoke SendMessage,hWin,WM_SETICON,NULL,eax
		invoke SetWindowPos,hMainDlg,HWND_BOTTOM,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE
		invoke GetDlgItem,hWin,IDC_RED2
		mov hRED1,eax
		invoke GetDlgItem,hWin,IDC_BTN1
		mov hBTN1,eax
		invoke GetDlgItem,hWin,IDC_BTN2
		mov hBTN2,eax
		invoke GetDlgItem,hWin,IDC_BTN3
		mov hBTN3,eax
		invoke GetDlgItem,hWin,IDC_BTN4
		mov hBTN4,eax
		invoke GetDlgItem,hWin,IDC_BTN9
		mov hBTN11,eax
		
		invoke CreateFontIndirect,offset Courier_New_8
		mov hCourirNew10,eax
		invoke SendMessage,hRED1,WM_SETFONT,hCourirNew10,TRUE
		
		invoke SendDlgItemMessage,hWin,IDC_RED2,EM_SETBKGNDCOLOR,0,00B7FFFFh
		
		invoke SendDlgItemMessage,hWin,IDC_RED2,WM_SETTEXT,0,lParam
		
		.if pTypeLibInfo==0
			invoke EnableWindow,hBTN3,FALSE 
		.endif
		
	.elseif uMsg==WM_COMMAND
		mov edx,wParam
		mov eax,edx
		shr edx,16
		.if dx==BN_CLICKED
; ======================================================================================================================
			.if ax==IDC_BTN1 ;Copy to Clipboard
				invoke OpenClipboard,hMainDlg
				invoke EmptyClipboard 
				invoke GlobalAlloc,GMEM_MOVEABLE + GMEM_ZEROINIT,sizeof buffer
				mov hClipboard,eax 
				invoke GlobalLock,hClipboard
				invoke SendMessage,hRED1,WM_GETTEXT,sizeof buffer,eax
				invoke GlobalUnlock,hClipboard 
				invoke SetClipboardData, CF_TEXT,hClipboard 
				invoke CloseClipboard
				
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
				invoke SetWindowPos,hMainDlg,HWND_BOTTOM,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE

; ======================================================================================================================
			.elseif ax==IDC_BTN9 ;Copy to RadAsm
				invoke GetDlgItemText,hWin,IDC_RED2,addr buffer,sizeof buffer
				
				mov edx,lpHStruct
				invoke SendMessage,[edx.ADDINHANDLES].hEdit,EM_REPLACESEL,TRUE,addr buffer
				invoke PostMessage,hWin,WM_CLOSE,NULL,NULL

; ======================================================================================================================
			.elseif ax==IDC_BTN2 ;info
				invoke DialogBoxParam,hInstance,IDD_DIALOG3,hWin,addr infoDlgProc,0

; ======================================================================================================================
			.elseif ax==IDC_BTN3 ;VB Browser
				invoke DialogBoxParam,hInstance,IDD_DIALOG4,hWin,addr VBBrowserProc,TKIND_DISPATCH
				
; ======================================================================================================================
			.elseif ax==IDC_BTN4 ;Close
				
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	
	.elseif uMsg==WM_SIZE
		mov eax,lParam
		mov edx,eax
		and eax,0FFFFh
		shr edx,16
		sub edx,40
		mov pos,edx
		invoke MoveWindow,hRED1,0,0,eax,pos,TRUE
		invoke GetWindowRect,hBTN1,addr rect
		add pos,8
		invoke MoveWindow,hBTN1,6,pos,100,25,TRUE		
		invoke MoveWindow,hBTN11,111,pos,100,25,TRUE		
		invoke MoveWindow,hBTN2,216,pos,100,25,TRUE		
		invoke MoveWindow,hBTN3,321,pos,100,25,TRUE	
		invoke MoveWindow,hBTN4,426,pos,100,25,TRUE		
		mov eax,TRUE 
		jmp return
		
	.elseif uMsg==WM_CLOSE
		invoke EndDialog,hWin,0
		
	.else
		mov eax,FALSE
		jmp return
	.endif
	mov eax,TRUE
; ======================================================================================================================

return:
	pop esi
	pop edi
	pop edx
	_finally
	ret

RadAsmDlgProc endp