ReturnType proc x:dword,pClass:dword
;Listing the ClassObject's return value (Pointer to other ClassObject)
	LOCAL pVarTypeInfo:dword
	LOCAL pRetTypeInfo:dword
	
	LOCAL number:dword
	LOCAL pWideAllocStr:dword
	LOCAL buffer[2048]:byte
	LOCAL printout[2048]:byte
	LOCAL flag:dword

	_try offset ED_41 ;address of frame-based exception director
	
	push edx
	push edi
	push esi

; ======================================================================================================================
	mov pVarTypeInfo,0
	mov pRetTypeInfo,0
	
;TIM.ReturnType
	mov eax,pClass
	mov edx,dword ptr [eax]
	lea eax,pVarTypeInfo
	push eax  ;ptr to ptr to function: VarTypeInfo
	push pClass
	;call MemberInfo.get_ReturnType
	call dword ptr [edx+14*4]
	.if eax==S_OK
		push number
		
;TIM.ReturnType.PointerLevel
		mov eax,pVarTypeInfo
		mov edx,dword ptr [eax]
		lea eax,number
		push eax ;ptr/VT_I2/
		push pVarTypeInfo
		;call VarTypeInfo.get_PointerLevel
		call dword ptr [edx+15*4]
		.if eax==S_OK
			mov eax,number
			and eax,0ffffh
			.if eax==1
			
;TIM.ReturnType.TypeInfo
				mov eax,pVarTypeInfo
				mov edx,dword ptr [eax]
				lea eax,pRetTypeInfo
				push eax  ;ptr to ptr to function: TypeInfo
				push pVarTypeInfo
				;call VarTypeInfo.get_TypeInfo
				call dword ptr [edx+10*4]
				.if eax==S_OK
				
;TIM.ReturnType.TypeInfo.Name
					mov eax,pRetTypeInfo
					mov edx,dword ptr [eax]
					lea eax,pWideAllocStr
					push eax ;ptr/VT_BSTR/
					push pRetTypeInfo
					;call TypeInfo.get_Name
					call dword ptr [edx+9*4]
					.if eax==S_OK
						invoke WideCharToMultiByte,CP_ACP,0,pWideAllocStr,-1,\
							addr buffer,sizeof buffer,0,0
						invoke SysFreeString,pWideAllocStr
						invoke wsprintf,addr printout,addr szPointer,addr buffer
						mov eax,pVarTypeInfo
						mov edx,dword ptr [eax]
						lea eax,flag
						push eax ;ptr/VT_BOOL/
						push pVarTypeInfo
						;call VarTypeInfo.get_IsExternalType
						call dword ptr [edx+13*4]
						and flag,0ffffh
						.if eax==S_OK && flag==VARIANT_TRUE
;							invoke lstrcat,addr printout,addr szExternal
							mov eax,pVarTypeInfo
							mov edx,dword ptr [eax]
							push offset pExtTypeLibInfo  ;ptr to ptr to function: TypeLibInfo
							push pVarTypeInfo
							;call VarTypeInfo.get_TypeLibInfoExternal
							call dword ptr [edx+14*4]
							.if eax==S_OK
								mov eax,pExtTypeLibInfo
								mov edx,dword ptr [eax]
								lea eax,pWideAllocStr
								push eax ;ptr/VT_BSTR/
								push pExtTypeLibInfo
								;call _TypeLibInfo.get_Name
								call dword ptr [edx+12*4]
								.if eax==S_OK
									invoke WideCharToMultiByte,CP_ACP,0,pWideAllocStr,-1,\
										addr buffer,sizeof buffer,0,0
									invoke SysFreeString,pWideAllocStr
									invoke lstrcat,addr printout,addr szLpar
									invoke lstrcat,addr printout,addr buffer
									invoke lstrcat,addr printout,addr szRpar
								.endif
							.endif
						.endif
						invoke putTextMatrix,x,3,addr printout
					.endif
					invoke IDispRelease,addr pRetTypeInfo
				.endif
			.endif
		.endif
		pop number
		invoke IDispRelease,addr pVarTypeInfo
	.endif
; ======================================================================================================================

return:
	pop esi
	pop edi
	pop edx
	_finally
	ret

ReturnType endp
