VBBrowserProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	_try offset ED_46 ;address of frame-based exception director
	
; ======================================================================================================================
	push hWin
	pop hVBwin
	.if uMsg==WM_INITDIALOG
		invoke LoadIcon,hInstance,IDI_ACTIVEX
		invoke SendMessage,hWin,WM_SETICON,NULL,eax
		invoke GetDlgItem,hWin,IDC_RED1
		mov hRED1,eax
		invoke SendMessage,hRED1,EM_SETTEXTMODE,0,TM_PLAINTEXT
		;Set event mask
		invoke SendMessage,hRED1,EM_SETEVENTMASK,0,ENM_SELCHANGE
		;Set the text limit. The default is 64K
		invoke SendMessage,hRED1,EM_LIMITTEXT,-1,0
		invoke SendMessage,hRED1,EM_SETMODIFY,FALSE,0
		invoke SendMessage,hRED1,EM_EMPTYUNDOBUFFER,0,0
		invoke SendMessage,hRED1,WM_SETTEXT,0,0
		invoke SendDlgItemMessage,hWin,IDC_RED1,EM_SETBKGNDCOLOR,0,colref
		invoke SetFocus,hRED1
		invoke GetDlgItem,hWin,IDC_LST1
		mov hLST1,eax
		invoke GetDlgItem,hWin,IDC_LST2
		mov hLST2,eax
		invoke SetWindowLong,hLST1,GWL_WNDPROC,addr LST1WndProc
		mov OldLST1WndProc,eax
		invoke SetWindowLong,hLST2,GWL_WNDPROC,addr LST2WndProc
		mov OldLST2WndProc,eax
		
		.if lParam==TKIND_DISPATCH
			invoke SendDlgItemMessage,hWin,IDC_STC1,WM_SETTEXT,0,addr szClasses
		.else
			invoke SendDlgItemMessage,hWin,IDC_STC1,WM_SETTEXT,0,addr szConstants
		.endif
		
		invoke Classes,lParam,0,FALSE,TRUE 
		
	.elseif uMsg==WM_CLOSE
		invoke EndDialog,hWin,0
		
	.else
		mov eax,FALSE
		jmp return
	.endif
	mov eax,TRUE
; ======================================================================================================================

return:
	_finally
	ret

VBBrowserProc endp

LST1WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL buffer[128]:byte
	LOCAL buffer2[128]:byte
	LOCAL TKind:dword
	
	_try offset ED_29 ;address of frame-based exception director
	
	push edx
	push edi
	push esi

; ======================================================================================================================
	.if uMsg==WM_LBUTTONUP
		invoke SendDlgItemMessage,hVBwin,IDC_STC1,WM_GETTEXT,sizeof buffer,addr buffer
		invoke lstrcmp,addr buffer,addr szClasses
		.if eax==0
			mov TKind,TKIND_DISPATCH
		.else
			mov TKind,TKIND_ENUM
		.endif
		
		invoke SendMessage,hLST2,LB_RESETCONTENT,0,0
		invoke SendMessage,hWin,LB_GETCURSEL,0,0
		mov edx,eax
		invoke SendMessage,hWin,LB_GETTEXT,edx,addr buffer
		invoke wsprintf,addr buffer2,addr szVBMembers,addr buffer
		invoke SendDlgItemMessage,hVBwin,IDC_STC2,WM_SETTEXT,0,addr buffer2
		
		invoke Members,TKind,addr buffer,TRUE 
	
	.endif
	invoke CallWindowProc,OldLST1WndProc,hLST1,uMsg,wParam,lParam
; ======================================================================================================================

return:
	pop esi
	pop edi
	pop edx
	_finally
	ret
	
LST1WndProc endp


LST2WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL buffer[128]:byte
	LOCAL buffer2[128]:byte
	
	_try offset ED_30 ;address of frame-based exception director
	
	push edx
	push edi
	push esi

; ======================================================================================================================
	.if uMsg==WM_LBUTTONUP
		invoke SendMessage,hWin,LB_GETCURSEL,0,0
		mov edx,eax
		invoke SendMessage,hWin,LB_GETTEXT,edx,addr buffer
		invoke SendMessage,hLST1,LB_GETCURSEL,0,0
		mov edx,eax
		invoke SendMessage,hLST1,LB_GETTEXT,edx,addr buffer2
		
	.endif
	invoke CallWindowProc,OldLST2WndProc,hLST2,uMsg,wParam,lParam
; ======================================================================================================================

return:
	pop esi
	pop edi
	pop edx
	_finally
	ret
	
LST2WndProc endp
