CheckLCID proc pClass:dword,Row:dword,pText:dword
	LOCAL pMembers:dword
	LOCAL pMemberInfo:dword
	LOCAL pParameters:dword
	LOCAL pParameterInfo:dword
	
	LOCAL number:dword
;	LOCAL lpWideCharStr[2048]:byte
	LOCAL pWideAllocStr:dword
	LOCAL buffer[2048]:byte

	_try offset ED_06 ;address of frame-based exception director
	
	push edx
	push edi
	push esi
	push ebx

; ======================================================================================================================
	mov pMembers,0
	mov pMemberInfo,0
	mov pParameters,0
	mov pParameterInfo,0
	
	mov eax,pClass ;pInterfaceInfo
	mov edx,dword ptr [eax]
	lea eax,pMembers
	push eax  ;ptr to ptr to function: Members
	push pClass
	;call InterfaceInfo.get_Members
	call dword ptr [edx+21*4]
	.if eax==S_OK
		mov eax,pMembers
		mov edx,dword ptr [eax]
		lea eax,pMemberInfo
		push eax  ;ptr to ptr to function: MemberInfo
		;Params( Index)
		mov eax,Row
		sub eax,6 ;IDISPATCH is not included in index
		push eax
		push pMembers
		;call Members.get_Item
		call dword ptr [edx+10*4]
		.if eax==S_OK
			mov eax,pMemberInfo
			mov edx,dword ptr [eax]
			lea eax,pParameters
			push eax  ;ptr to ptr to function: Parameters
			push pMemberInfo
			;call MemberInfo.get_Parameters
			call dword ptr [edx+13*4]
			.if eax==S_OK
				mov eax,pParameters
				mov edx,dword ptr [eax]
				lea eax,number
				push eax ;ptr/VT_I2/
				push pParameters
				;call Parameters.get_Count
				call dword ptr [edx+11*4]
				.if eax==S_OK
					and number,0ffffh
					mov ecx,1
					.while ecx<=number
						push ecx
						mov eax,pParameters
						mov edx,dword ptr [eax]
						lea eax,pParameterInfo
						push eax  ;ptr to ptr to function: ParameterInfo
						;Params( Index)
						push ecx
						push pParameters
						;call Parameters.get_Item
						call dword ptr [edx+10*4]
						.if eax==S_OK
							mov eax,pParameterInfo
							mov edx,dword ptr [eax]
							lea eax,pWideAllocStr
							push eax ;ptr/VT_BSTR/
							push pParameterInfo
							;call ParameterInfo.get_Name
							call dword ptr [edx+9*4]
							.if eax==S_OK
								invoke WideCharToMultiByte,CP_ACP,0,pWideAllocStr,-1,\
									addr buffer,sizeof buffer,0,0
								invoke SysFreeString,pWideAllocStr
								invoke lstrcmp,addr buffer,addr szlcid
								mov edi,eax
								invoke lstrcmp,addr buffer,addr szLCID
								mov esi,eax
								.if edi==0 || esi==0
									mov eax,TRUE 
									jmp return
								.endif
							.endif
						.endif
						invoke IDispRelease,addr pParameterInfo
						pop ecx
						inc ecx
					.endw
				.endif
				invoke IDispRelease,addr pParameters
			.endif
			invoke IDispRelease,addr pMemberInfo
		.endif
		invoke IDispRelease,addr pMembers
	.endif
	mov eax,FALSE 
	
; ======================================================================================================================

return:
	pop ebx
	pop esi
	pop edi
	pop edx
	_finally
	ret
	
CheckLCID endp